
	DEVICE = 16F628
	XTAL = 4
 
	LCD_DTPIN = PORTB.4
	LCD_RSPIN = PORTB.3
	LCD_ENPIN = PORTB.2
	LCD_INTERFACE = 4	' 4-bit Interface
	LCD_LINES = 2
	LCD_TYPE = 0

	SCL_PIN	= PORTA.0
	SDA_PIN	= PORTA.1

	SERIAL_BAUD = 9600
	RSOUT_PIN = PORTB.0
	RSOUT_MODE = TRUE
	RSOUT_PACE = 1
	RSIN_PIN = PORTB.1
	RSIN_MODE = TRUE
	RSIN_TIMEOUT = 2000


	KEYPAD_PORT = PORTB

	Symbol T300 = 3313
	Symbol N300 = 3313 + $4000
	Symbol T600 = 1646
	Symbol N600 = 1646 + $4000
	Symbol T1200 = 813
	Symbol N1200 = 813 + $4000
	Symbol T2400 = 396
	Symbol N2400 = 396 + $4000
	Symbol T4800 = 188
	Symbol N4800 = 188 + $4000
	Symbol T9600 = 84
	Symbol N9600 = 84 + $4000

	Symbol OT2400 = 396 + $8000	       			' Open True
	Symbol OT1200 = 813 + $8000	       			' Open True
	Symbol OT9600 = 84 + $8000	      			' Open True
	Symbol OT300  = 3313 + $8000	      		' Open True

	Symbol ON2400 = 396 + $4000 + $8000	      	' Open Inverted
	Symbol ON1200 = 813 + $4000 + $8000	      	' Open Inverted
	Symbol ON9600 = 84 + $4000 + $8000	      	' Open Inverted
	Symbol ON300  = 3313 + $4000 + $8000 	    ' Open Inverted

' Rsout / Serial Constants
	Symbol HOME = 1
	Symbol BELL = 7
	Symbol BKSP = 8
	Symbol TAB = 9
	Symbol CR = 13

	ALL_DIGITAL = TRUE	' Set PORTA and PORTE to all digital
