'
' Header file for the Proton Development Board
' Using a 18F452 Device with a 24MHz Oscillator
'
	DEVICE = 18F452
	XTAL = 24

	LCD_DTPIN = PORTD.4
	LCD_RSPIN = PORTE.0
	LCD_ENPIN = PORTE.1
	LCD_INTERFACE = 4
	LCD_LINES = 2
	LCD_TYPE = 0
	LCD_COMMANDUS = 2000
	LCD_DATAUS = 50

	SCL_PIN	= PORTC.3
	SDA_PIN	= PORTC.4


	SERIAL_BAUD = 9600
	RSOUT_PIN = PORTC.6
	RSOUT_MODE = TRUE
	RSOUT_PACE = 1
	RSIN_PIN = PORTC.7
	RSIN_MODE = TRUE


	HSERIAL_BAUD = 9600				' Set baud rate to 9600
	HSERIAL_RCSTA = %10010000       ' Enable serial port and continuous receive
	HSERIAL_TXSTA = %00100100       ' Enable transmit and asynchronous mode
	HSERIAL_CLEAR = ON				' Enable Error clearing on received characters


	KEYPAD_PORT = PORTB

	CCP1_PIN = PORTC.2
	CCP2_PIN = PORTC.1

	Symbol T300 = 3313
	Symbol N300 = 3313 + $4000
	Symbol T600 = 1646
	Symbol N600 = 1646 + $4000
	Symbol T1200 = 813
	Symbol N1200 = 813 + $4000
	Symbol T2400 = 396
	Symbol N2400 = 396 + $4000
	Symbol T4800 = 188
	Symbol N4800 = 188 + $4000
	Symbol T9600 = 84
	Symbol N9600 = 84 + $4000

	Symbol OT2400 = 396 + $8000	       			' Open True
	Symbol OT1200 = 813 + $8000	       			' Open True
	Symbol OT9600 = 84 + $8000	      			' Open True
	Symbol OT300  = 3313 + $8000	      		' Open True

	Symbol ON2400 = 396 + $4000 + $8000	      	' Open Inverted
	Symbol ON1200 = 813 + $4000 + $8000	      	' Open Inverted
	Symbol ON9600 = 84 + $4000 + $8000	      	' Open Inverted
	Symbol ON300  = 3313 + $4000 + $8000 	    ' Open Inverted

' Rsout / Serial Constants
	Symbol HOME = 1
	Symbol BELL = 7
	Symbol BKSP = 8
	Symbol TAB = 9
	Symbol CR = 13

	ALL_DIGITAL = TRUE	' Set PORTA and PORTE to all digital



