'
' Header file for the Proton Development Board
' Using a 18F452 Device with a 4MHz Oscillator
'
	Device = 18F452
	Xtal = 4

	LCD_DTPin = PORTD.4
	LCD_RSPin = PORTE.0
	LCD_ENPin = PORTE.1
	LCD_Interface = 4
	LCD_Lines = 2
	LCD_Type = 0

	SCL_Pin	= PORTC.3
	SDA_Pin	= PORTC.4

	Serial_Baud = 9600
	Rsout_Pin = PORTC.6
	Rsout_Mode = TRUE
	Rsout_Pace = 1
	Rsin_Pin = PORTC.7
	Rsin_Mode = TRUE


	Hserial_Baud = 9600			' Set baud rate to 9600
	Hserial_RCSTA = %10010000   ' Enable serial port and continuous receive
	Hserial_TXSTA = %00100100   ' Enable transmit and asynchronous mode
	Hserial_Clear = On			' Enable Error clearing on received characters


	Keypad_Port = PORTB

	CCP1_Pin = PORTC.2
	CCP2_Pin = PORTC.1

	Symbol T300 = 3313
	Symbol N300 = 3313 + $4000
	Symbol T600 = 1646
	Symbol N600 = 1646 + $4000
	Symbol T1200 = 813
	Symbol N1200 = 813 + $4000
	Symbol T2400 = 396
	Symbol N2400 = 396 + $4000
	Symbol T4800 = 188
	Symbol N4800 = 188 + $4000
	Symbol T9600 = 84
	Symbol N9600 = 84 + $4000

	Symbol OT2400 = 396 + $8000	       			' Open True
	Symbol OT1200 = 813 + $8000	       			' Open True
	Symbol OT9600 = 84 + $8000	      			' Open True
	Symbol OT300  = 3313 + $8000	      		' Open True

	Symbol ON2400 = 396 + $4000 + $8000	      	' Open Inverted
	Symbol ON1200 = 813 + $4000 + $8000	      	' Open Inverted
	Symbol ON9600 = 84 + $4000 + $8000	      	' Open Inverted
	Symbol ON300  = 3313 + $4000 + $8000 	    ' Open Inverted

' Rsout / Serial Constants
	Symbol HOME = 1
	Symbol BELL = 7
	Symbol BKSP = 8
	Symbol TAB = 9
	Symbol CR = 13

	All_Digital = TRUE	' Set PORTA and PORTE to all digital



