;
; Full Speed USB Driver Subroutines Based On Microchip's Supplied C Code Version 1.2.
; Implementing a CDC Interface
;
Check@StdRequest
    movlb high(_USB#RAM_START)
    Movf __SETUPPKT,W
    Andlw 0x60
    Sublw (__STANDARD << 5)
    Bnz Check@StdRequestExit
    Movlw __SET_ADR
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@StdRequest1
    Movlw __ADR_PENDING_STATE
    Movwf __USB_DEVICE_STATE
    Bra Std@SetSessionOwnerUSB9
Check@StdRequest1
    Movlw __GET_DSC
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@StdRequest2
    Bra Std@GetDscHandler
Check@StdRequest2
    Movlw __GET_CFG
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@StdRequest3
NOLIST
if((__USB_ACTIVE_CFG & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__USB_ACTIVE_CFG & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__USB_ACTIVE_CFG & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__USB_ACTIVE_CFG >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__USB_ACTIVE_CFG >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__USB_ACTIVE_CFG >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra Std@SetSessionOwnerUSB9
Check@StdRequest3
    Movlw __SET_CFG
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra Std@SetCfgHandler
	Movf __SETUPPKT + __BREQUEST,W
    Bz Std@GetStatusHandler
    Movlw __CLR_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra Std@FeatureReqHandler
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra Std@FeatureReqHandler
    Movlw __GET_INTF
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@StdRequest8
NOLIST
if((__USB_ALT_INTF & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__USB_ALT_INTF & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__USB_ALT_INTF & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__USB_ALT_INTF >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__USB_ALT_INTF >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__USB_ALT_INTF >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movf __SETUPPKT + __BINTFID,W
    Addwf __PSRC,F
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra Std@SetSessionOwnerUSB9
Check@StdRequest8
    Movlw __SET_INTF
    Cpfseq __SETUPPKT + __BREQUEST
    Return
    Lfsr 2,__USB_ALT_INTF
    Movf __SETUPPKT + __BINTFID,W
    Movff __SETUPPKT + __bAltID,PLUSW2
Std@SetSessionOwnerUSB9
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
Check@StdRequestExit
    Return
;---------------------------------
Std@GetDscHandler
    movlb high(_USB#RAM_START)
    Movlw 128
    Cpfseq __SETUPPKT + __BMREQUESTTYPE
    Return
    Movlw __DSC_DEV
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra Std@GetDscHandler1
NOLIST
if((__DEVICEDESCRIPTOR & 255) == 0)
LIST
    Clrf __PSRC
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__DEVICEDESCRIPTOR & 255) == 255)
LIST
    Setf __PSRC
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__DEVICEDESCRIPTOR & 255)
    Movwf __PSRC
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__DEVICEDESCRIPTOR >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__DEVICEDESCRIPTOR >> 8) & 255) == 255)
LIST
    Setf __PSRCH
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__DEVICEDESCRIPTOR >> 8) & 255)
    Movwf __PSRCH
    MOvwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*
    Movff TABLAT,__WCOUNT
    Clrf __WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra Std@SetSessionOwnerUSB9
Std@GetDscHandler1
    Movlw __DSC_CFG
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra Std@GetDscHandler2
NOLIST
if((___CONFIG1 & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((___CONFIG1 & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (___CONFIG1 & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((___CONFIG1 >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((___CONFIG1 >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((___CONFIG1 >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
NOLIST
if((__CONFIG1LEN & 255) == 0)
LIST
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__CONFIG1LEN & 255) == 255)
LIST
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__CONFIG1LEN & 255)
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CONFIG1LEN >> 8) & 255) == 0)
LIST
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__CONFIG1LEN >> 8) & 255) == 255)
LIST
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__CONFIG1LEN >> 8) & 255)
    Movwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*+
    Movff TABLAT,__WCOUNT
    Tblrd*+
    Tblrd*
    Movff TABLAT,__WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra Std@SetSessionOwnerUSB9
Std@GetDscHandler2
    Movlw __DSC_STR
    Cpfseq __SETUPPKT + __BDSCTYPE
    Return
    Clrf TBLPTRH
    Rlncf __SETUPPKT + __BDSCINDEX,W
    Addlw (__USB_SD_Ptr & 255)
    Movwf TBLPTRL
    Movlw ((__USB_SD_Ptr >> 8) & 255)
    addwfc TBLPTRH,F
    Tblrd*+
    Movff TABLAT,__PSRC
    Tblrd*
    Movf TABLAT,W
    Movwf __PSRCH
    Movwf TBLPTRH
    Movff __PSRC,TBLPTRL
    Tblrd*
    Movff TABLAT,__WCOUNT
    Clrf __WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra Std@SetSessionOwnerUSB9
;---------------------------------
Std@SetCfgHandler
    movlb high(_USB#RAM_START)
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
    Lfsr 2,UEP1
    Movlw 15
Std@SetCfgHandlerClearEPLoop
    Clrf POSTINC2
    Decfsz WREG,F
    Bra Std@SetCfgHandlerClearEPLoop
    Lfsr 2,__USB_ALT_INTF
    Movlw __MAX_NUM_INT
Std@SetCfgHandlerClearAltLoop
    Clrf POSTINC2
    Decfsz WREG,F
    Bra Std@SetCfgHandlerClearAltLoop
    Movf __SETUPPKT + __BCFGVALUE,W
    Movwf __USB_ACTIVE_CFG
    Bnz Std@SetCfgHandler1
    Movlw __ADDRESS_STATE
    Movwf __USB_DEVICE_STATE
    Return
Std@SetCfgHandler1
    Movlw __CONFIGURED_STATE
    Movwf __USB_DEVICE_STATE
    Bra CDCInit@EP
;---------------------------------
Std@GetStatusHandler
    movlb high(_USB#RAM_START)
    Clrf __CTRLTRFDATA
    Clrf __CTRLTRFDATA + 1
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_DEV
    Bnz Std@GetStatusHandler1
NOLIST
ifdef USB_BUS_SELF_POWER#REQ
LIST
    Bsf __CTRLTRFDATA,0
NOLIST
endif
LIST
    Btfsc __USB_STAT,__REMOTEWAKEUP
    Bsf __CTRLTRFDATA,1
    Bra Std@GetStatusSetSessionOwner
Std@GetStatusHandler1
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_INTF
    Bnz Std@GetStatusHandler2
    Bra Std@GetStatusSetSessionOwner
Std@GetStatusHandler2
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_EP
    Bnz Std@GetStatusHandler3
    Rcall Calc@EPAddress
    Movf INDF2,W
    Andlw _BSTALL
    Bz Std@GetStatusSetSessionOwner
    Bsf __CTRLTRFDATA,0
Std@GetStatusSetSessionOwner
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
Std@GetStatusHandler3
    Movlw __MUID_USB9
    Cpfseq __CTRL_TRF_SESSION_OWNER
    Return
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 2
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Return
;---------------------------------
Std@FeatureReqHandler
    movlb high(_USB#RAM_START)
    Movlw __DEVICE_REMOTE_WAKEUP
    Cpfseq __SETUPPKT + __BFEATURE
    Bra Std@FeatureReqHandler1
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_DEV
    Bnz Std@FeatureReqHandler1
    Bsf __USB_STAT,__REMOTEWAKEUP
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bcf __USB_STAT,__REMOTEWAKEUP
    Bra Std@SetSessionOwnerUSB9
Std@FeatureReqHandler1
    Movlw __ENDPOINT_HALT
    Cpfseq __SETUPPKT + __BFEATURE
Std@FeatureReqHandlerExit
    Return
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_EP
    Bnz Std@FeatureReqHandlerExit
    Movf __SETUPPKT + __BEPID,W
    Andlw 0x0F
    Bz Std@FeatureReqHandlerExit
    Rcall Calc@EPAddress
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Std@FeatureReqHandler2
    Movlw _USIE | _BSTALL
    Movwf INDF2
    Bra Std@SetSessionOwnerUSB9
Std@FeatureReqHandler2
    Movlw _UCPU
    Btfss __SETUPPKT + __BEPID,__EPDIR
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf INDF2
    Bra Std@SetSessionOwnerUSB9
Calc@EPAddress
    Lfsr 2,__EP0BO
    Rlncf __SETUPPKT + __BEPID,W
    rlcf __SETUPPKT + __BEPID,W
    Rlncf WREG,F
    Rlncf WREG,F
    Addwf FSR2L,F
    Return
Ctrl@EPService
    Clrf __TRNIFCLEARED
    Movlw __EP00_OUT
    Cpfseq USTAT
    Bra Ctrl@EPService1
    Bcf UIR,PP_TRNIF
    Setf __TRNIFCLEARED
    Movf __EP0BO + __STAT,W
    Andlw 0x3C
    Sublw (__SETUP_TOKEN << 2)
    Bz Ctrl@TrfSetupHandler
    Bra Ctrl@TrfOutHandler
Ctrl@EPService1
    Movlw __EP00_IN
    Cpfseq USTAT
    Return
    Bcf UIR,PP_TRNIF
    Setf __TRNIFCLEARED
;---------------------------------
Ctrl@TrfInHandler
    Movlw __ADR_PENDING_STATE
    Cpfseq __USB_DEVICE_STATE
    Bra Ctrl@TrfInHandler1
    Movf __SETUPPKT + __bDevADR,W
NOLIST
if (UADDR < 0XF60)
LIST
    Movlb ((UADDR >> 8) & 255)
NOLIST
endif
LIST
    Movwf UADDR
    movlb high(_USB#RAM_START)
    Movlw __ADDRESS_STATE
    Btfsc STATUS,Z
    Movlw __DEFAULT_STATE
    Movwf __USB_DEVICE_STATE
Ctrl@TrfInHandler1
    Movlw __CTRL_TRF_TX
    Cpfseq __CTRL_TRF_STATE
    Bra Prepare@FNSTrf
    Rcall Ctrl@TrfTxService
    movlb high(_USB#RAM_START)
    Movlw __SHORT_PKT_SENT
    Cpfseq __SHORT_PKT_STATUS
    Bra    CTL@TRFINHDL2
    Movlw _USIE | _BSTALL
    Movwf __EP0BI + __STAT
    Return
CTL@TRFINHDL2
    Movlw _USIE | _DAT1 | _DTSEN
    Btfsc __EP0BI + __STAT,__DTS
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf __EP0BI + __STAT
    Return
;---------------------------------
Ctrl@TrfSetupHandler
    Movlw _UCPU
    Btfsc __EP0BI + __STAT,__UOWN
    Movwf __EP0BI + __STAT
    Movlw __SHORT_PKT_NOT_USED
    Movwf __SHORT_PKT_STATUS
    Movlw __WAIT_SETUP
    Movwf __CTRL_TRF_STATE
    Clrf __CTRL_TRF_SESSION_OWNER
    Clrf __WCOUNT
    Clrf __WCOUNTH
    Rcall Check@StdRequest
    Movf __CTRL_TRF_SESSION_OWNER,W
    Bnz Ctrl@EPServiceComplete
    Rcall Check@CDCRequest
    Bra Ctrl@EPServiceComplete
;---------------------------------
Ctrl@TrfOutHandler
    Movlw __CTRL_TRF_RX
    Cpfseq __CTRL_TRF_STATE
    Bra Prepare@FNSTrf
    Rcall Ctrl@TrfRxService
    Movlw _USIE | _DAT1 | _DTSEN
    Btfsc __EP0BO + __STAT,__DTS
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf __EP0BO + __STAT
    Return
;---------------------------------
Ctrl@TrfTxService
    movlb high(_USB#RAM_START)
    Movf __WCOUNT,W
    Movwf __USB_TEMP_VAR
    Movf __WCOUNTH,W
    Movwf __USB_TEMP_VARH
    Sublw ((__EP0_BUFF_SIZE >> 8) & 255)
    Bnz CTL@TRFTXSVCNE
    Movf __WCOUNT,W
    Sublw (__EP0_BUFF_SIZE & 255)
    Bz CTL@TRFTXSVCSB
CTL@TRFTXSVCNE
    Bnc CTL@TRFTXSVCMX
    Movlw __SHORT_PKT_NOT_USED
    Cpfseq __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCNE1
    Movlw __SHORT_PKT_PENDING
    Movwf __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
CTL@TRFTXSVCNE1
    Movlw __SHORT_PKT_PENDING
    Cpfseq __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
    Movlw __SHORT_PKT_SENT
    Movwf __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
CTL@TRFTXSVCMX
    Movlw __EP0_BUFF_SIZE
    Movwf __USB_TEMP_VAR
    Clrf __USB_TEMP_VARH
CTL@TRFTXSVCSB
    Movf __USB_TEMP_VAR,W
    Movwf __EP0BI + __CNT
    Subwf __WCOUNT,F
    Movf __USB_TEMP_VARH,W
    Subwfb __WCOUNTH,F
    Movf __EP0BI + __STAT,W
    Andlw 0XFC
    Iorwf __USB_TEMP_VARH,W
    Movwf __EP0BI + __STAT
    Lfsr 2,__CTRLTRFDATA
    Movf __USB_TEMP_VARH,W
    Bnz CTL@TRFTXSVCROMRAM
    Movf __USB_TEMP_VAR,W
    Bz CTL@TRFTXSVCEXIT
CTL@TRFTXSVCROMRAM
    Btfss __USB_STAT,__CTRL_TRF_MEM
    Bra CTL@TRFTXSVCRM
    Movff __PSRC,TBLPTRL
    Movff __PSRCH,TBLPTRH
CTL@TRFTXSVCROMLP
    Tblrd*+
    Movff TABLAT,POSTINC2
    Tblrd*+
    Decf __USB_TEMP_VAR,F
    Bnz CTL@TRFTXSVCROMLP
    Decf __USB_TEMP_VARH,F
    Bc CTL@TRFTXSVCROMLP
    Movff TBLPTRL,__PSRC
    Movff TBLPTRH,__PSRCH
    Return
CTL@TRFTXSVCRM
    Movff __PSRC,FSR1L
    Movff __PSRCH,FSR1H
CTL@TRFTXSVCRMLP
    Movff POSTINC1,POSTINC2
    Decf __USB_TEMP_VAR,F
    Bnz CTL@TRFTXSVCRMLP
    Decf __USB_TEMP_VARH,F
    Bc CTL@TRFTXSVCRMLP
    Movff FSR1L,__PSRC
    Movff FSR1H,__PSRCH
CTL@TRFTXSVCEXIT
    Return
;---------------------------------
Ctrl@TrfRxService
    movlb high(_USB#RAM_START)
    Movf __EP0BO + __CNT,W
    Movwf __USB_TEMP_VAR
    Addwf __WCOUNT,F
    Movf __EP0BO + __STAT,W
    Andlw 3
    Movwf __USB_TEMP_VARH
    addwfc    __WCOUNTH,F
    Lfsr 1,__CTRLTRFDATA
    Movff __PDST,FSR2L
    Movff __PDSTH,FSR2H
    Movf __USB_TEMP_VARH,W
    Bnz Ctrl@TrfRxServiceLoop
    Movf __USB_TEMP_VAR,W
    Bz Ctrl@TrfRxServiceExit
Ctrl@TrfRxServiceLoop
    Movff POSTINC1,POSTINC2
    Decf __USB_TEMP_VAR,F
    Bnz Ctrl@TrfRxServiceLoop
    Decf __USB_TEMP_VARH,F
    Bc Ctrl@TrfRxServiceLoop
    Movff FSR2L,__PDST
    Movff FSR2H,__PDSTH
Ctrl@TrfRxServiceExit
    Return
;---------------------------------
Ctrl@EPServiceComplete
    Bcf UCON,PP_PKTDIS
    Movf __CTRL_TRF_SESSION_OWNER
    Bnz Ctrl@EPServiceComplete1
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__SETUPPKT & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__SETUPPKT & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__SETUPPKT >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__SETUPPKT >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _BSTALL
    Movwf __EP0BO + __STAT
    Movwf __EP0BI + __STAT
    Bra Ctrl@EPServiceCompleteExit
Ctrl@EPServiceComplete1
    Btfss __SETUPPKT,__DATADIR
    Bra Ctrl@EPServiceComplete2
    Movf __WCOUNTH,W
    Subwf __SETUPPKT + __WLENGTH + 1,W
    Bnc Ctrl@EPServiceCompleteCopy
    Bnz Ctrl@EPServiceComplete11
    Movf __WCOUNT,W
    Subwf __SETUPPKT + __WLENGTH,W
    Bc Ctrl@EPServiceComplete11
Ctrl@EPServiceCompleteCopy
    Movff __SETUPPKT + __WLENGTH,__WCOUNT
    Movff __SETUPPKT + __WLENGTH + 1,__WCOUNTH
Ctrl@EPServiceComplete11
    Rcall Ctrl@TrfTxService
    Movlw __CTRL_TRF_TX
    Movwf __CTRL_TRF_STATE
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__SETUPPKT & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__SETUPPKT & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__SETUPPKT >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__SETUPPKT >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE
    Movwf __EP0BO + __STAT
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __EP0BI + __ADRL
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __EP0BI + __ADRL
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __EP0BI + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __EP0BI + __ADRH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __EP0BI + __ADRH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __EP0BI + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BI + __STAT
    Bra Ctrl@EPServiceCompleteExit
Ctrl@EPServiceComplete2
    Movlw __CTRL_TRF_RX
    Movwf __CTRL_TRF_STATE
    Clrf __EP0BI + __CNT
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BI + __STAT
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BO + __STAT
Ctrl@EPServiceCompleteExit
    Bcf UCON,PP_PKTDIS
    Return
;-------------------------------------------------------
Prepare@FNSTrf
    movlb high(_USB#RAM_START)
    Movlw __CTRL_TRF_RX
    Cpfseq __CTRL_TRF_STATE
    Bra PREP@FNSTRF1
    Btfss UCON,PP_PKTDIS
    Bra PREP@FNSTRF1
    Movlw __EP0_BUFF_SIZE
    Cpfseq __EP0BO + __CNT
    Bra PREP@FNSTRF1
    Movf __EP0BO + __STAT,W
    Andlw 0X3C
    Sublw (__SETUP_TOKEN << 2)
    Bnz    PREP@FNSTRF1
    Btfsc __EP0BI + __STAT,__UOWN
    Bra PREP@FNSTRF1
    Lfsr 1,__CTRLTRFDATA
    Lfsr 2,__SETUPPKT
    Movlw __EP0_BUFF_SIZE
PREP@FNSTRFLP
    Movff POSTINC1,POSTINC2
    Decfsz WREG,F
    Bra PREP@FNSTRFLP
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
    Return
PREP@FNSTRF1
    Movlw __WAIT_SETUP
    Movwf __CTRL_TRF_STATE
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
    Movlw _USIE | _DAT0 | _DTSEN | _BSTALL
    Movwf __EP0BO + __STAT
    Movlw _UCPU
    Movwf __EP0BI + __STAT
    Return
;-----------------------------------------------------
InitialiseUSB@Driver
    Clrf TBLPTRU
NOLIST
if (UCFG < 0X0F60)
LIST
    Movlb ((UCFG >> 8) & 255)
NOLIST
endif
LIST
    Movlw __UCFG_VAL
    Movwf UCFG
    movlb high(_USB#RAM_START)
    Clrf __USB_DEVICE_STATE
    Clrf __USB_STAT
    Clrf __USB_ACTIVE_CFG
    Bra CDCINIT@EP
;-----------------------------------------------------
Check@BusStatus
    Clrf TBLPTRU
    movlb high(_USB#RAM_START)
NOLIST
ifdef USB_BUS_SENSE_IO#REQ
LIST
    Btfss USB_BUS#SENSE
    Bra Check@BusStatusDetached
NOLIST
endif
LIST
    Btfss UCON,PP_USBEN
    Rcall MODULE@ENABLE
NOLIST
ifdef USB_BUS_SENSE_IO#REQ
LIST
    Bra CHK@BSTAT1
CHK@BSTATDETACHED
    Btfsc UCON,PP_USBEN
    Rcall MODULE@DISABLE
NOLIST
endif
LIST
CHK@BSTAT1
    Movlw __ATTACHED_STATE
    Cpfseq __USB_DEVICE_STATE
    Return
    Btfsc UCON,PP_SE0
    Return
    Clrf UIR
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    Bsf UIE,PP_URSTIE
    Bsf UIE,PP_IDLEIE
    movlb high(_USB#RAM_START)
    Movlw __POWERED_STATE
    Movwf __USB_DEVICE_STATE
    Return
;--------------------------------------------
Module@Enable
    Clrf UCON
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    Bsf UCON,PP_USBEN
    movlb high(_USB#RAM_START)
    Movlw __ATTACHED_STATE
    Movwf __USB_DEVICE_STATE
    Return
;--------------------------------------------
Module@Disable
    Clrf UCON
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    movlb high(_USB#RAM_START)
    Clrf __USB_DEVICE_STATE
    Return
;---------------------------------
Driver@Service
    movlb high(_USB#RAM_START)
    Movlw __DETACHED_STATE
    Subwf __USB_DEVICE_STATE,W
    Bz Driver@ServiceExit
    Btfss UIR,PP_ACTVIF
    Bra Driver@Service1
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_ACTVIE
    Rcall Wake@FromSuspend
Driver@Service1
    Btfsc UCON,PP_SUSPND
    Return
    Btfss UIR,PP_URSTIF
    Bra $ + 6
    Btfsc UIE,PP_URSTIE
    Rcall Protocol@ResetHandler
    Btfss UIR,PP_IDLEIF
    Bra Driver@Service2
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_IDLEIE
    Rcall Suspend@USB
Driver@Service2
    Btfss UIR,PP_SOFIF
    Bra Driver@Service3
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_SOFIE
    Bcf UIR,PP_SOFIF
Driver@Service3
    Btfss UIR,PP_STALLIF
    Bra Driver@Service4
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_STALLIE
    Rcall Stall@Handler
Driver@Service4
    Btfss UIR,PP_UERRIF
    Bra Driver@Service5
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_UERRIE
    Bcf UIR,PP_UERRIF
Driver@Service5
    Movlw __DEFAULT_STATE
    Subwf __USB_DEVICE_STATE,W
    Bnc Driver@ServiceExit
    Btfss UIR,PP_TRNIF
    Bra Driver@ServiceExit
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfss UIE,PP_TRNIE
    Bra Driver@ServiceExit
    Rcall Ctrl@EPService
    Bcf UIR,PP_TRNIF
Driver@ServiceExit
    Return
;---------------------------------
Suspend@USB
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Bsf UIE,PP_ACTVIE
    Bcf UIR,PP_IDLEIF
    Bsf UCON,PP_SUSPND
    Return
;---------------------------------
Wake@FromSuspend
    Bcf UCON,PP_SUSPND
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Bcf UIE, PP_ACTVIE
    Bcf UIR,PP_ACTVIF
    Btfsc UIR,PP_ACTVIF
    Bra $ - 4
    Return
;---------------------------------
Remote@Wakeup
    movlb high(_USB#RAM_START)
    Btfss __USB_STAT,__REMOTEWAKEUP
    Return
    Bcf UCON,PP_SUSPND
    Bsf UCON,PP_RESUME
    Movlw 0X10
    Movwf PRODH
    Clrf PRODL
    Decfsz PRODL,F
    Bra $ - 2
    Decfsz PRODH,F
    Bra $ - 6
    Bcf UCON,PP_RESUME
    Return
;---------------------------------
Stall@Handler
NOLIST
if (UEP0 < 0X0F60)
LIST
    Movlb ((UEP0 >> 8) & 255)
NOLIST
endif
LIST
    Btfss UEP0,PP_EPSTALL
    Bra STL@EX
    movlb high(_USB#RAM_START)
    Movlw _USIE
    Cpfseq __EP0BO + __STAT
    Bra STL@EX
    Movlw _USIE | _BSTALL
    Cpfseq __EP0BI + __STAT
    Bra STL@EX
    Movlw _USIE | _DAT0 | __DTSEN | _BSTALL
    Movwf __EP0BO + __STAT
NOLIST
if (UEP0 < 0X0F60)
LIST
    Movlb ((UEP0 >> 8) & 255)
NOLIST
endif
LIST
    Bcf UEP0,PP_EPSTALL
STL@EX
    Bcf UIR,PP_STALLIF
    Return
;---------------------------------
Protocol@ResetHandler
NOLIST
if (UEIR < 0X0F60)
LIST
    Movlb ((UEIR >> 8) & 255)
NOLIST
endif
LIST
    Clrf UEIR
    Clrf UIR
NOLIST
if (UEIE < 0X0F60)
LIST
    Movlb ((UEIE >> 8) & 255)
NOLIST
endif
LIST
    Movlw 0X9F
    Movwf UEIE
    Movlw 0X7B
    Movwf UIE
    Clrf UADDR
    Lfsr 2,UEP1
    Movlw 15
    Clrf POSTINC2
    Decfsz WREG,F
    Bra $ - 4
    Movlw __EP_CTRL | __HSHK_EN
    Movwf UEP0
    Bra $ + 10
    Bcf UIR,PP_TRNIF
    Bra $ + 2
    Bra $ + 2
    Bra $ + 2
    Btfsc UIR,PP_TRNIF
    Bra $ - 10
    Bcf UCON,PP_PKTDIS
    Rcall PREPARE@FNSTRF
    movlb high(_USB#RAM_START)
    Bcf __USB_STAT,__REMOTEWAKEUP
    Clrf __USB_ACTIVE_CFG
    Movlw __DEFAULT_STATE
    Movwf __USB_DEVICE_STATE
    Return
;---------------------------------
Check@CDCRequest
    movlb high(_USB#RAM_START)
    Movf __SETUPPKT,W
    Andlw 0x1F
    Sublw __RCPT_INTF
    Bnz Check@CDCRqstExit
    Movf __SETUPPKT,W
    Andlw 0x60
    Sublw (__CLASS << 5)
    Bnz Check@CDCRqstExit
    Movlw __CDC_COMM_INTF_ID
    Subwf __SETUPPKT + __BINTFID,W
    Bz Check@CDCRqst1
    Movlw __CDC_DATA_INTF_ID
    Cpfseq __SETUPPKT + __BINTFID
Check@CDCRqstExit
    Return
Check@CDCRqst1
    Movlw __SEND_ENCAPSULATED_COMMAND
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst2
NOLIST
if((__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Movlw __DUMMY_LENGTH
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bra USBCDCSetSessionOwner
Check@CDCRqst2
    Movlw __GET_ENCAPSULATED_RESPONSE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst3
NOLIST
if((__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255) == 0)
LIST
    Clrf __PDST
NOLIST
else
LIST
NOLIST
if((__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255) == 255)
LIST
    Setf __PDST
NOLIST
else
LIST
    Movlw (__DUMMY_ENCAPSULATED_CMD_RESPONSE & 255)
    Movwf __PDST
NOLIST
endif
NOLIST
endif
NOLIST
if(((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255) == 0)
LIST
    Clrf __PDSTH
NOLIST
else
NOLIST
if(((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255) == 255)
LIST
    Setf __PDSTH
NOLIST
else
LIST
    Movlw ((__DUMMY_ENCAPSULATED_CMD_RESPONSE >> 8) & 255)
    Movwf __PDSTH
NOLIST
endif
NOLIST
endif
LIST
    Bra USBCDCSetSessionOwner
Check@CDCRqst3
    Movlw __SET_COMM_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst4
    Return
Check@CDCRqst4
    Movlw __GET_COMM_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst5
    Return
Check@CDCRqst5
    Movlw __CLEAR_COMM_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst6
    Return
Check@CDCRqst6
    Movlw __SET_LINE_CODING
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst7
NOLIST
if((__LINE_CODING & 255) == 0)
LIST
    Clrf __PDST
NOLIST
else
LIST
NOLIST
if((__LINE_CODING & 255) == 255)
LIST
    Setf __PDST
NOLIST
else
LIST
    Movlw (__LINE_CODING & 255)
    Movwf __PDST
NOLIST
endif
NOLIST
endif
NOLIST
if(((__LINE_CODING >> 8) & 255) == 0)
LIST
    Clrf __PDSTH
NOLIST
else
NOLIST
if(((__LINE_CODING >> 8) & 255) == 255)
LIST
    Setf __PDSTH
NOLIST
else
LIST
    Movlw ((__LINE_CODING >> 8) & 255)
    Movwf __PDSTH
NOLIST
endif
NOLIST
endif
LIST
    Bra USBCDCSetSessionOwner
Check@CDCRqst7
    Movlw __GET_LINE_CODING
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst8
; Baud rate of the USB interface
NOLIST
if((115200 & 255) == 0)
LIST
    Clrf __LINE_CODING + __DWDTERATE
NOLIST
else
LIST
NOLIST
if((115200 & 255) == 255)
LIST
    Setf __LINE_CODING + __DWDTERATE
NOLIST
else
LIST
    Movlw (115200 & 255)
    Movwf __LINE_CODING + __DWDTERATE
NOLIST
endif
NOLIST
endif
NOLIST
if(((115200 >> 8) & 255) == 0)
LIST
    Clrf __LINE_CODING + __DWDTERATE + 1
NOLIST
else
NOLIST
if(((115200 >> 8) & 255) == 255)
LIST
    Setf __LINE_CODING + __DWDTERATE + 1
NOLIST
else
LIST
    Movlw ((115200 >> 8) & 255)
    Movwf __LINE_CODING + __DWDTERATE + 1
NOLIST
endif
NOLIST
endif
NOLIST
if(((115200 >> 16) & 255) == 0)
LIST
    Clrf __LINE_CODING + __DWDTERATE + 2
NOLIST
else
NOLIST
if(((115200 >> 16) & 255) == 255)
LIST
    Setf __LINE_CODING + __DWDTERATE + 2
NOLIST
else
LIST
    Movlw ((115200 >> 16) & 255)
    Movwf __LINE_CODING + __DWDTERATE + 2
NOLIST
endif
NOLIST
endif
LIST
    Clrf __LINE_CODING + __DWDTERATE + 3
    Clrf __LINE_CODING + __BCHARFORMAT   ; 1 stop bit
    Clrf __LINE_CODING + __BPARITYTYPE   ; No Parity
    Movlw 8
    Movwf __LINE_CODING + __BDATABITS   ; 5, 6, 7, 8, or 16 data bits
NOLIST
if((__LINE_CODING & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__LINE_CODING & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__LINE_CODING & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__LINE_CODING >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__LINE_CODING >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__LINE_CODING >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Movlw __LINE_CODING_LENGTH
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bra USBCDCSetSessionOwner
Check@CDCRqst8
    Movlw __SET_CONTROL_LINE_STATE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst9
    Movff __SETUPPKT + __WVALUE,__CONTROL_SIGNAL_BITMAP
    Bra USBCDCSetSessionOwner
Check@CDCRqst9
    Movlw __SEND_BREAK
    Cpfseq __SETUPPKT + __BREQUEST
    Bra Check@CDCRqst10
    Return
Check@CDCRqst10
    Return
USBCDCSetSessionOwner
    Movlw __MUID_CDC
    Movwf __CTRL_TRF_SESSION_OWNER
    Return
;---------------------------------
CDCInit@EP
    Movlw 2
    Movwf FSR0L
    Lfsr 1,__CDC_NOTICE
    Movlw __CDC_INT_EP_SIZE
    Rcall InitEP@In
    Movlw 3
    Movwf FSR0L
    Lfsr 1,__CDC_DATA_RX
    Movlw __CDC_BULK_OUT_EP_SIZE
    Movwf POSTINC1
    Lfsr 2,UEP0
    Movf FSR0L,W
    Addwf FSR2L,F
    Movlw __EP_OUT | __HSHK_EN
    Iorwf INDF2,F
    Rlncf FSR0L,W
    Rlncf WREG,F
    Rlncf  WREG,F
    Lfsr 0,__EP0BO
    Addwf FSR0L,F
    Movlw __ADRL
    Movff FSR1L,PLUSW0
    Movlw __ADRH
    Movff FSR1H,PLUSW0
    Movf POSTDEC1,W
    Incf FSR0L,F
    Movff INDF1,POSTDEC0
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf INDF0
    Movlw 3
    Movwf FSR0L
    Lfsr 1,__CDC_DATA_TX
    Movlw __CDC_BULK_IN_EP_SIZE
InitEP@In
    Movwf POSTINC1
    Lfsr 2,UEP0
    Movf FSR0L,W
    Addwf FSR2L,F
    Movlw __EP_IN | __HSHK_EN
    Iorwf INDF2,F
    Rlncf FSR0L,W
    Rlncf WREG,F
    Rlncf WREG,F
    Lfsr 0,__EP0BI
    Addwf FSR0L,F
    Movlw __ADRL
    Movff FSR1L,PLUSW0
    Movlw __ADRH
    Movff FSR1H,PLUSW0
    Movlw _UCPU | _DAT1
    Movwf INDF0
    Return
