;
; Full Speed USB Driver Subroutines Based On Microchip's Supplied C Code Version 1.2.
; Implementing a HID Interface
;
CHK@STRQS
    movlb high(_USB#RAM_START)
    Movf __SETUPPKT,W
    Andlw 0X60
    Sublw (__STANDARD << 5)
    Bnz CHK@STRQSEX
    Movlw __SET_ADR
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CHK@STRQS1
    Movlw __ADR_PENDING_STATE
    Movwf __USB_DEVICE_STATE
    Bra STD@SETSOWNUSB9
CHK@STRQS1
    Movlw __GET_DSC
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CHK@STRQS2
    Bra STD@GDSCHDL
CHK@STRQS2
    Movlw __GET_CFG
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CHK@STRQS3
NOLIST
if((__USB_ACTIVE_CFG & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__USB_ACTIVE_CFG & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__USB_ACTIVE_CFG & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__USB_ACTIVE_CFG >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__USB_ACTIVE_CFG >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__USB_ACTIVE_CFG >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra STD@SETSOWNUSB9
CHK@STRQS3
    Movlw __SET_CFG
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra STD@SCFGHDL
    Movf __SETUPPKT + __BREQUEST,W
    Bz STD@GTSTATHDL
    Movlw __CLR_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra STD@FTRRQHDL
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra $ + 4
    Bra STD@FTRRQHDL
    Movlw __GET_INTF
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CHK@STRQS8
NOLIST
if((__USB_ALT_INTF & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__USB_ALT_INTF & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__USB_ALT_INTF & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__USB_ALT_INTF >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__USB_ALT_INTF >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__USB_ALT_INTF >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movf __SETUPPKT + __BINTFID,W
    Addwf __PSRC,F
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra STD@SETSOWNUSB9
CHK@STRQS8
    Movlw __SET_INTF
    Cpfseq __SETUPPKT + __BREQUEST
    Return
    Lfsr 2,__USB_ALT_INTF
    Movf __SETUPPKT + __BINTFID,W
    Movff __SETUPPKT + __BALTID,PLUSW2
STD@SETSOWNUSB9
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
CHK@STRQSEX
    Return
;---------------------------------
STD@GDSCHDL
    movlb high(_USB#RAM_START)
    Movlw 128
    Cpfseq __SETUPPKT + __BMREQUESTTYPE
    Return
    Movlw __DSC_DEV
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra STD@GDSCHDL1
NOLIST
if((__DEVICEDESCRIPTOR & 255) == 0)
LIST
    Clrf __PSRC
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__DEVICEDESCRIPTOR & 255) == 255)
LIST
    Setf __PSRC
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__DEVICEDESCRIPTOR & 255)
    Movwf __PSRC
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__DEVICEDESCRIPTOR >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__DEVICEDESCRIPTOR >> 8) & 255) == 255)
LIST
    Setf __PSRCH
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__DEVICEDESCRIPTOR >> 8) & 255)
    Movwf __PSRCH
    MOvwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*
    Movff TABLAT,__WCOUNT
    Clrf __WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra STD@SETSOWNUSB9
STD@GDSCHDL1
    Movlw __DSC_CFG
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra STD@GDSCHDL2
NOLIST
if((___CONFIG1 & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((___CONFIG1 & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (___CONFIG1 & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((___CONFIG1 >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((___CONFIG1 >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((___CONFIG1 >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
NOLIST
if((__CONFIG1LEN & 255) == 0)
LIST
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__CONFIG1LEN & 255) == 255)
LIST
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__CONFIG1LEN & 255)
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CONFIG1LEN >> 8) & 255) == 0)
LIST
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__CONFIG1LEN >> 8) & 255) == 255)
LIST
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__CONFIG1LEN >> 8) & 255)
    Movwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*+
    Movff TABLAT,__WCOUNT
    Tblrd*+
    Tblrd*
    Movff TABLAT,__WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra STD@SETSOWNUSB9
STD@GDSCHDL2
    Movlw __DSC_STR
    Cpfseq __SETUPPKT + __BDSCTYPE
    Return
    Clrf TBLPTRH
    Rlncf __SETUPPKT + __BDSCINDEX,W
    Addlw (__USB_SD_PTR & 255)
    Movwf TBLPTRL
    Movlw ((__USB_SD_PTR >> 8) & 255)
    Addwfc TBLPTRH,F
    Tblrd*+
    Movff TABLAT,__PSRC
    Tblrd*
    Movf TABLAT,W
    Movwf __PSRCH
    Movwf TBLPTRH
    Movff __PSRC,TBLPTRL
    Tblrd*
    Movff TABLAT,__WCOUNT
    Clrf __WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra STD@SETSOWNUSB9
;---------------------------------
STD@SCFGHDL
    movlb high(_USB#RAM_START)
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
    Lfsr 2,UEP1
    Movlw 15
STD@SCFGHDLCLREPLP
    Clrf POSTINC2
    Decfsz WREG,F
    Bra STD@SCFGHDLCLREPLP
    Lfsr 2,__USB_ALT_INTF
    Movlw __MAX_NUM_INT
STD@SCFGHDLCLRALTLP
    Clrf POSTINC2
    Decfsz WREG,F
    Bra STD@SCFGHDLCLRALTLP
    Movf __SETUPPKT + __BCFGVALUE,W
    Movwf __USB_ACTIVE_CFG
    Bnz STD@SCFGHDL1
    Movlw __ADDRESS_STATE
    Movwf __USB_DEVICE_STATE
    Return
STD@SCFGHDL1
    Movlw __CONFIGURED_STATE
    Movwf __USB_DEVICE_STATE
    Bra HIDINIT@EP
;---------------------------------
STD@GTSTATHDL
    movlb high(_USB#RAM_START)
    Clrf __CTRLTRFDATA
    Clrf __CTRLTRFDATA + 1
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_DEV
    Bnz STD@GTSTATHDL1
NOLIST
ifdef USB_BUS_SELF_POWER#REQ
LIST
    Bsf __CTRLTRFDATA,0
NOLIST
endif
LIST
    Btfsc __USB_STAT,__REMOTEWAKEUP
    Bsf __CTRLTRFDATA,1
    Bra STD@GTSTATSESOWN
STD@GTSTATHDL1
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_INTF
    Bnz STD@GTSTATHDL2
    Bra STD@GTSTATSESOWN
STD@GTSTATHDL2
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_EP
    Bnz STD@GTSTATHDL3
    Rcall CL@EPADR
    Movf INDF2,W
    Andlw _BSTALL
    Bz STD@GTSTATSESOWN
    Bsf __CTRLTRFDATA,0
STD@GTSTATSESOWN
    Movlw __MUID_USB9
    Movwf __CTRL_TRF_SESSION_OWNER
STD@GTSTATHDL3
    Movlw __MUID_USB9
    Cpfseq __CTRL_TRF_SESSION_OWNER
    Return
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 2
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Return
;---------------------------------
STD@FTRRQHDL
    movlb high(_USB#RAM_START)
    Movlw __DEVICE_REMOTE_WAKEUP
    Cpfseq __SETUPPKT + __BFEATURE
    Bra STD@FTRRQHDL1
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_DEV
    Bnz STD@FTRRQHDL1
    Bsf __USB_STAT,__REMOTEWAKEUP
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bcf __USB_STAT,__REMOTEWAKEUP
    Bra STD@SETSOWNUSB9
STD@FTRRQHDL1
    Movlw __ENDPOINT_HALT
    Cpfseq __SETUPPKT + __BFEATURE
STD@FTRRQHDLEX
    Return
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_EP
    Bnz STD@FTRRQHDLEX
    Movf __SETUPPKT + __BEPID,W
    Andlw 0X0F
    Bz STD@FTRRQHDLEX
    Rcall CL@EPADR
    Movlw __SET_FEATURE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra STD@FTRRQHDL2
    Movlw _USIE | _BSTALL
    Movwf INDF2
    Bra STD@SETSOWNUSB9
STD@FTRRQHDL2
    Movlw _UCPU
    Btfss __SETUPPKT + __BEPID,__EPDIR
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf INDF2
    Bra STD@SETSOWNUSB9
CL@EPADR
    Lfsr 2,__EP0BO
    Rlncf __SETUPPKT + __BEPID,W
    Rlcf __SETUPPKT + __BEPID,W
    Rlncf WREG,F
    Rlncf WREG,F
    Addwf FSR2L,F
    Return
CTL@EPSVC
    Clrf __TRNIFCLEARED
    Movlw __EP00_OUT
    Cpfseq USTAT
    Bra    CTL@EPSVC1
    Bcf    UIR,PP_TRNIF
    Setf __TRNIFCLEARED
    Movf __EP0BO + __STAT,W
    Andlw 0X3C
    Sublw (__SETUP_TOKEN << 2)
    Bz CTL@TRFSETUPHDL
    Bra CTL@TRFOUTHDL
CTL@EPSVC1
    Movlw __EP00_IN
    Cpfseq USTAT
    Return
    Bcf    UIR,PP_TRNIF
    Setf __TRNIFCLEARED
    Bra    CTL@TRFINHDL
;---------------------------------
CTL@TRFSETUPHDL
    movlb high(_USB#RAM_START)
    Movlw _UCPU
    Btfsc __EP0BI + __STAT,__UOWN
    Movwf __EP0BI + __STAT
    Movlw __SHORT_PKT_NOT_USED
    Movwf __SHORT_PKT_STATUS
    Movlw __WAIT_SETUP
    Movwf __CTRL_TRF_STATE
    Movlw __MUID_NULL
    Movwf __CTRL_TRF_SESSION_OWNER
    Clrf __WCOUNT
    Clrf __WCOUNTH
    Rcall CHK@STRQS
    movlb high(_USB#RAM_START)
    Movlw __MUID_NULL
    Cpfseq __CTRL_TRF_SESSION_OWNER
    Bra CTL@EPSVCCP
    Rcall CK@HRQST
    Bra CTL@EPSVCCP
;---------------------------------
CTL@TRFOUTHDL
    movlb high(_USB#RAM_START)
    Movlw __CTRL_TRF_RX
    Cpfseq __CTRL_TRF_STATE
    Bra PREPARE@FNSTRF
    Rcall CTL@TRFRXSERVICE
    movlb high(_USB#RAM_START)
    Movlw _USIE | _DAT1 | _DTSEN
    Btfsc __EP0BO + __STAT,__DTS
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf __EP0BO + __STAT
    Return
;---------------------------------
CTL@TRFINHDL
    movlb high(_USB#RAM_START)
    Movlw __ADR_PENDING_STATE
    Cpfseq __USB_DEVICE_STATE
    Bra CTL@TRFINHDL1
    Movf __SETUPPKT + __BDEVADR,W
NOLIST
if (UADDR < 0XF60)
LIST
    Movlb ((UADDR >> 8) & 255)
NOLIST
endif
LIST
    Movwf UADDR
    movlb high(_USB#RAM_START)
    Movlw __ADDRESS_STATE
    Btfsc STATUS,Z
    Movlw __DEFAULT_STATE
    Movwf __USB_DEVICE_STATE
CTL@TRFINHDL1
    Movlw __CTRL_TRF_TX
    Cpfseq __CTRL_TRF_STATE
    Bra PREPARE@FNSTRF
    Rcall CTL@TRFTXSVC
    movlb high(_USB#RAM_START)
    Movlw __SHORT_PKT_SENT
    Cpfseq __SHORT_PKT_STATUS
    Bra    CTL@TRFINHDL2
    Movlw _USIE | _BSTALL
    Movwf __EP0BI + __STAT
    Return
CTL@TRFINHDL2
    Movlw _USIE | _DAT1 | _DTSEN
    Btfsc __EP0BI + __STAT,__DTS
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf __EP0BI + __STAT
    Return
;---------------------------------
CTL@TRFTXSVC
    movlb high(_USB#RAM_START)
    Movf __WCOUNT,W
    Movwf __USB_TEMP_VAR
    Movf __WCOUNTH,W
    Movwf __USB_TEMP_VARH
    Sublw ((__EP0_BUFF_SIZE >> 8) & 255)
    Bnz CTL@TRFTXSVCNE
    Movf __WCOUNT,W
    Sublw (__EP0_BUFF_SIZE & 255)
    Bz CTL@TRFTXSVCSB
CTL@TRFTXSVCNE
    Bnc CTL@TRFTXSVCMX
    Movlw __SHORT_PKT_NOT_USED
    Cpfseq __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCNE1
    Movlw __SHORT_PKT_PENDING
    Movwf __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
CTL@TRFTXSVCNE1
    Movlw __SHORT_PKT_PENDING
    Cpfseq __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
    Movlw __SHORT_PKT_SENT
    Movwf __SHORT_PKT_STATUS
    Bra CTL@TRFTXSVCSB
CTL@TRFTXSVCMX
    Movlw __EP0_BUFF_SIZE
    Movwf __USB_TEMP_VAR
    Clrf __USB_TEMP_VARH
CTL@TRFTXSVCSB
    Movf __USB_TEMP_VAR,W
    Movwf __EP0BI + __CNT
    Subwf __WCOUNT,F
    Movf __USB_TEMP_VARH,W
    Subwfb __WCOUNTH,F
    Movf __EP0BI + __STAT,W
    Andlw 0XFC
    Iorwf __USB_TEMP_VARH,W
    Movwf __EP0BI + __STAT
    Lfsr 2,__CTRLTRFDATA
    Movf __USB_TEMP_VARH,W
    Bnz CTL@TRFTXSVCROMRAM
    Movf __USB_TEMP_VAR,W
    Bz CTL@TRFTXSVCEXIT
CTL@TRFTXSVCROMRAM
    Btfss __USB_STAT,__CTRL_TRF_MEM
    Bra CTL@TRFTXSVCRM
    Movff __PSRC,TBLPTRL
    Movff __PSRCH,TBLPTRH
CTL@TRFTXSVCROMLP
    Tblrd*+
    Movff TABLAT,POSTINC2
    Tblrd*+
    Decf __USB_TEMP_VAR,F
    Bnz CTL@TRFTXSVCROMLP
    Decf __USB_TEMP_VARH,F
    Bc CTL@TRFTXSVCROMLP
    Movff TBLPTRL,__PSRC
    Movff TBLPTRH,__PSRCH
    Return
CTL@TRFTXSVCRM
    Movff __PSRC,FSR1L
    Movff __PSRCH,FSR1H
CTL@TRFTXSVCRMLP
    Movff POSTINC1,POSTINC2
    Decf __USB_TEMP_VAR,F
    Bnz CTL@TRFTXSVCRMLP
    Decf __USB_TEMP_VARH,F
    Bc CTL@TRFTXSVCRMLP
    Movff FSR1L,__PSRC
    Movff FSR1H,__PSRCH
CTL@TRFTXSVCEXIT
    Return
;---------------------------------
CTL@TRFRXSERVICE
    movlb high(_USB#RAM_START)
    Movf __EP0BO + __CNT,W
    Movwf __USB_TEMP_VAR
    Addwf __WCOUNT,F
    Movf __EP0BO + __STAT,W
    Andlw 3
    Movwf __USB_TEMP_VARH
    Addwfc    __WCOUNTH,F
    Lfsr 1,__CTRLTRFDATA
    Movff __PDST,FSR2L
    Movff __PDSTH,FSR2H
    Movf __USB_TEMP_VARH,W
    Bnz CTL@TRFRXSVCLP
    Movf __USB_TEMP_VAR,W
    Bz CTL@TRFRXSVCEX
CTL@TRFRXSVCLP
    Movff POSTINC1,POSTINC2
    Decf __USB_TEMP_VAR,F
    Bnz CTL@TRFRXSVCLP
    Decf __USB_TEMP_VARH,F
    Bc CTL@TRFRXSVCLP
    Movff FSR2L,__PDST
    Movff FSR2H,__PDSTH
CTL@TRFRXSVCEX
    Return
;---------------------------------
CTL@EPSVCCP
    movlb high(_USB#RAM_START)
    Bcf UCON,PP_PKTDIS
    Movlw __MUID_NULL
    Cpfseq __CTRL_TRF_SESSION_OWNER
    Bra CTL@EPSVCCP1
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__SETUPPKT & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__SETUPPKT & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__SETUPPKT >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__SETUPPKT >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _BSTALL
    Movwf __EP0BO + __STAT
    Movwf __EP0BI + __STAT
    Return
CTL@EPSVCCP1
    Btfss __SETUPPKT,__DATADIR
    Bra CTL@EPSVCCP2
    Movf __WCOUNTH,W
    Subwf __SETUPPKT + __WLENGTH + 1,W
    Bnc CTL@EPSVCCPCPY
    Bnz CTL@EPSVCCP11
    Movf __WCOUNT,W
    Subwf __SETUPPKT + __WLENGTH,W
    Bc CTL@EPSVCCP11
CTL@EPSVCCPCPY
    Movff __SETUPPKT + __WLENGTH,__WCOUNT
    Movff __SETUPPKT + __WLENGTH + 1,__WCOUNTH
CTL@EPSVCCP11
    Rcall CTL@TRFTXSVC
    movlb high(_USB#RAM_START)
    Movlw __CTRL_TRF_TX
    Movwf __CTRL_TRF_STATE
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__SETUPPKT & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__SETUPPKT & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__SETUPPKT >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__SETUPPKT >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE
    Movwf __EP0BO + __STAT
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __EP0BI + __ADRL
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __EP0BI + __ADRL
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __EP0BI + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __EP0BI + __ADRH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __EP0BI + __ADRH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __EP0BI + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BI + __STAT
    Return
CTL@EPSVCCP2
    Movlw __CTRL_TRF_RX
    Movwf __CTRL_TRF_STATE
    Clrf __EP0BI + __CNT
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BI + __STAT
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
NOLIST
if((__CTRLTRFDATA & 255) == 0)
LIST
    Clrf __EP0BO + __ADRL
NOLIST
else
LIST
NOLIST
if((__CTRLTRFDATA & 255) == 255)
LIST
    Setf __EP0BO + __ADRL
NOLIST
else
LIST
    Movlw (__CTRLTRFDATA & 255)
    Movwf __EP0BO + __ADRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 0)
LIST
    Clrf __EP0BO + __ADRH
NOLIST
else
NOLIST
if(((__CTRLTRFDATA >> 8) & 255) == 255)
LIST
    Setf __EP0BO + __ADRH
NOLIST
else
LIST
    Movlw ((__CTRLTRFDATA >> 8) & 255)
    Movwf __EP0BO + __ADRH
NOLIST
endif
NOLIST
endif
LIST
    Movlw _USIE | _DAT1 | _DTSEN
    Movwf __EP0BO + __STAT
    Return
;---------------------------------
PREPARE@FNSTRF
    movlb high(_USB#RAM_START)
    Movlw __CTRL_TRF_RX
    Cpfseq __CTRL_TRF_STATE
    Bra PREP@FNSTRF1
    Btfss UCON,PP_PKTDIS
    Bra PREP@FNSTRF1
    Movlw __EP0_BUFF_SIZE
    Cpfseq __EP0BO + __CNT
    Bra PREP@FNSTRF1
    Movf __EP0BO + __STAT,W
    Andlw 0X3C
    Sublw (__SETUP_TOKEN << 2)
    Bnz    PREP@FNSTRF1
    Btfsc __EP0BI + __STAT,__UOWN
    Bra PREP@FNSTRF1
    Lfsr 1,__CTRLTRFDATA
    Lfsr 2,__SETUPPKT
    Movlw __EP0_BUFF_SIZE
PREP@FNSTRFLP
    Movff POSTINC1,POSTINC2
    Decfsz WREG,F
    Bra PREP@FNSTRFLP
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
    Return
PREP@FNSTRF1
    Movlw __WAIT_SETUP
    Movwf __CTRL_TRF_STATE
    Movlw __EP0_BUFF_SIZE
    Movwf __EP0BO + __CNT
    Movlw (__SETUPPKT & 255)
    Movwf __EP0BO + __ADRL
    Movlw ((__SETUPPKT >> 8) & 255)
    Movwf __EP0BO + __ADRH
    Movlw _USIE | _DAT0 | _DTSEN | _BSTALL
    Movwf __EP0BO + __STAT
    Movlw _UCPU
    Movwf __EP0BI + __STAT
    Return
;---------------------------------
INITIALISEUSB@DRIVER
    Clrf TBLPTRU
NOLIST
if (UCFG < 0X0F60)
LIST
    Movlb ((UCFG >> 8) & 255)
NOLIST
endif
LIST
    Movlw __UCFG_VAL
    Movwf UCFG
    movlb high(_USB#RAM_START)
    Movlw __DETACHED_STATE
    Movwf __USB_DEVICE_STATE
    Clrf __USB_STAT
    Clrf __USB_ACTIVE_CFG
    Bra HIDINIT@EP
;---------------------------------
CHECK@BUSSTATUS
    movlb high(_USB#RAM_START)
NOLIST
ifdef USB_BUS_SENSE_IO#REQ
LIST
    Btfss USB_BUS#SENSE
    Bra CHK@BSTATDETACHED
NOLIST
endif
LIST
    Btfss UCON,PP_USBEN
    Rcall MODULE@ENABLE
NOLIST
ifdef USB_BUS_SENSE_IO#REQ
LIST
    Bra CHK@BSTAT1
CHK@BSTATDETACHED
    Btfsc UCON,PP_USBEN
    Rcall MODULE@DISABLE
NOLIST
endif
LIST
CHK@BSTAT1
    Movlw __ATTACHED_STATE
    Cpfseq __USB_DEVICE_STATE
    Return
    Btfsc UCON,PP_SE0
    Return
    Clrf UIR
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    Bsf UIE,PP_URSTIE
    Bsf UIE,PP_IDLEIE
    movlb high(_USB#RAM_START)
    Movlw __POWERED_STATE
    Movwf __USB_DEVICE_STATE
    Return
;--------------------------------------------
MODULE@ENABLE
    Clrf UCON
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    Bsf UCON,PP_USBEN
    movlb high(_USB#RAM_START)
    Movlw __ATTACHED_STATE
    Movwf __USB_DEVICE_STATE
    Return
;--------------------------------------------
MODULE@DISABLE
    Clrf UCON
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Clrf UIE
    movlb high(_USB#RAM_START)
    Movlw __DETACHED_STATE
    Movwf __USB_DEVICE_STATE
    Return
;---------------------------------
DRIVER@SERVICE
    movlb high(_USB#RAM_START)
    Movlw __DETACHED_STATE
    Subwf __USB_DEVICE_STATE,W
    Bz DRV@SVCEX
    Btfss UIR,PP_ACTVIF
    Bra DRV@SVC1
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_ACTVIE
    Rcall WAKE@FROMSUSPEND
DRV@SVC1
    Btfsc UCON,PP_SUSPND
    Return
    Btfss UIR,URSTIF
    Bra DRV@SVC2
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_URSTIE
    Rcall PROTOCOL@RESETHDL
DRV@SVC2
    Btfss UIR,PP_IDLEIF
    Bra DRV@SVC3
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_IDLEIE
    Rcall SUSPEND@USB
DRV@SVC3
    Btfss UIR,PP_SOFIF
    Bra DRV@SVC4
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfss UIE,PP_SOFIE
    Bra $ + 6
    Bcf UIR,PP_SOFIF
    Return
DRV@SVC4
    Btfss UIR,PP_STALLIF
    Bra DRV@SVC5
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfsc UIE,PP_STALLIE
    Rcall STALL@HDL
DRV@SVC5
    Btfss UIR,PP_UERRIF
    Bra DRV@SVC6
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfss UIE,PP_UERRIE
NOLIST
if (UEIR < 0X0F60)
LIST
    Movlb ((UEIR >> 8) & 255)
NOLIST
endif
LIST
    Bra $ + 6
    Clrf UEIR
    Return
DRV@SVC6
    movlb high(_USB#RAM_START)
    Movlw __DEFAULT_STATE
    Subwf __USB_DEVICE_STATE,W
    Bnc    DRV@SVCEX
    Movlw 4
    Movwf __BTRNIFCOUNT
DRV@SVC7
    Btfss UIR,PP_TRNIF
    Return
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Btfss UIE,PP_TRNIE
    Return
    Rcall CTL@EPSVC
    movlb high(_USB#RAM_START)
    Btfss __TRNIFCLEARED,0
    Bcf UIR,PP_TRNIF
    Bra $ + 2
    Bra $ + 2
    Decfsz __BTRNIFCOUNT,F
    Bra DRV@SVC7
DRV@SVCEX
    Return
;---------------------------------
SUSPEND@USB
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Bsf UIE,PP_ACTVIE
    Bcf UIR,PP_IDLEIF
    Bsf UCON,PP_SUSPND
    Return
;---------------------------------
WAKE@FROMSUSPEND
    Bcf UCON,PP_SUSPND
NOLIST
if (UIE < 0X0F60)
LIST
    Movlb ((UIE >> 8) & 255)
NOLIST
endif
LIST
    Bcf UIE, PP_ACTVIE
    Bcf UIR,PP_ACTVIF
    Btfsc UIR,PP_ACTVIF
    Bra $ - 4
    Return
;---------------------------------
REMOTE@WAKEUP
    movlb high(_USB#RAM_START)
    Btfss __USB_STAT,__REMOTEWAKEUP
    Return
    Bcf UCON,PP_SUSPND
    Bsf UCON,PP_RESUME
    Movlw 0X10
    Movwf PRODH
    Clrf PRODL
    Decfsz PRODL,F
    Bra $ - 2
    Decfsz PRODH,F
    Bra $ - 6
    Bcf UCON,PP_RESUME
    Return
;---------------------------------
STALL@HDL
NOLIST
if (UEP0 < 0X0F60)
LIST
    Movlb ((UEP0 >> 8) & 255)
NOLIST
endif
LIST
    Btfss UEP0,PP_EPSTALL
    Bra STL@EX
    movlb high(_USB#RAM_START)
    Movlw _USIE
    Cpfseq __EP0BO + __STAT
    Bra STL@EX
    Movlw _USIE | _BSTALL
    Cpfseq __EP0BI + __STAT
    Bra STL@EX
    Movlw _USIE | _DAT0 | __DTSEN | _BSTALL
    Movwf __EP0BO + __STAT
NOLIST
if (UEP0 < 0X0F60)
LIST
    Movlb ((UEP0 >> 8) & 255)
NOLIST
endif
LIST
    Bcf UEP0,PP_EPSTALL
STL@EX
    Bcf UIR,PP_STALLIF
    Return
;---------------------------------
PROTOCOL@RESETHDL
NOLIST
if (UEIR < 0X0F60)
LIST
    Movlb ((UEIR >> 8) & 255)
NOLIST
endif
LIST
    Clrf UEIR
    Clrf UIR
NOLIST
if (UEIE < 0X0F60)
LIST
    Movlb ((UEIE >> 8) & 255)
NOLIST
endif
LIST
    Movlw 0X9F
    Movwf UEIE
    Movlw 0X7B
    Movwf UIE
    Clrf UADDR
    Lfsr 2,UEP1
    Movlw 15
    Clrf POSTINC2
    Decfsz WREG,F
    Bra $ - 4
    Movlw __EP_CTRL | __HSHK_EN
NOLIST
if (UEP0 < 0X0F60)
LIST
    Movlb ((UEP0 >> 8) & 255)
NOLIST
endif
LIST
    Movwf UEP0
    Bra $ + 10
    Bcf UIR,PP_TRNIF
    Bra $ + 2
    Bra $ + 2
    Bra $ + 2
    Btfsc UIR,PP_TRNIF
    Bra $ - 10
    Bcf UCON,PP_PKTDIS
    Rcall PREPARE@FNSTRF
    movlb high(_USB#RAM_START)
    Bcf __USB_STAT,__REMOTEWAKEUP
    Clrf __USB_ACTIVE_CFG
    Movlw __DEFAULT_STATE
    Movwf __USB_DEVICE_STATE
    Return
;---------------------------------
CK@HRQST
    movlb high(_USB#RAM_START)
    Movf __SETUPPKT,W
    Andlw 0X1F
    Sublw __RCPT_INTF
    Bnz CHK@HRQSEX
    Movlw __HID_INTF_ID
    Cpfseq __SETUPPKT + __BINTFID
CHK@HRQSEX
    Return
    Movlw __GET_DSC
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CK@HRQCLS
    Movlw __DSC_HID
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra CK@HRQ
NOLIST
if((__HIDDESCRIPTOR1 & 255) == 0)
LIST
    Clrf __PSRC
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__HIDDESCRIPTOR1 & 255) == 255)
LIST
    Setf __PSRC
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__HIDDESCRIPTOR1 & 255)
    Movwf __PSRC
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__HIDDESCRIPTOR1 >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__HIDDESCRIPTOR1 >> 8) & 255) == 255)
LIST
    Setf __PSRCH
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__HIDDESCRIPTOR1 >> 8) & 255)
    Movwf __PSRCH
    Movwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*
    Movff TABLAT, __WCOUNT
    Clrf __WCOUNTH
    Bsf __USB_STAT,__CTRL_TRF_MEM
    Bra H@SSNOWN
CK@HRQ
    Movlw __DSC_RPT
    Cpfseq __SETUPPKT + __BDSCTYPE
    Bra CHK@HRQS2
NOLIST
if((__REPORTDESCRIPTOR1 & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__REPORTDESCRIPTOR1 & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__REPORTDESCRIPTOR1 & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__REPORTDESCRIPTOR1 >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__REPORTDESCRIPTOR1 >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__REPORTDESCRIPTOR1 >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
NOLIST
if((__REPORTDESCRIPTOR1LEN & 255) == 0)
LIST
    Clrf TBLPTRL
NOLIST
else
LIST
NOLIST
if((__REPORTDESCRIPTOR1LEN & 255) == 255)
LIST
    Setf TBLPTRL
NOLIST
else
LIST
    Movlw (__REPORTDESCRIPTOR1LEN & 255)
    Movwf TBLPTRL
NOLIST
endif
NOLIST
endif
NOLIST
if(((__REPORTDESCRIPTOR1LEN >> 8) & 255) == 0)
LIST
    Clrf TBLPTRH
NOLIST
else
NOLIST
if(((__REPORTDESCRIPTOR1LEN >> 8) & 255) == 255)
LIST
    Setf TBLPTRH
NOLIST
else
LIST
    Movlw ((__REPORTDESCRIPTOR1LEN >> 8) & 255)
    Movwf TBLPTRH
NOLIST
endif
NOLIST
endif
LIST
    Tblrd*+
    Movff TABLAT,__WCOUNT
    Tblrd*+
    Tblrd*
    Movff TABLAT,__WCOUNTH
    Bsf __USB_STAT, __CTRL_TRF_MEM
    Bra H@SSNOWN
CHK@HRQS2
CK@HRQCLS
    Movf __SETUPPKT,W
    Andlw 0X60
    Sublw (__CLASS << 5)
    Bnz CHK@HRQSEX
    Movlw __GET_IDLE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CK@HRQCLSL
NOLIST
if((__IDLE_RATE & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
LIST
NOLIST
if((__IDLE_RATE & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__IDLE_RATE & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__IDLE_RATE >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__IDLE_RATE >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__IDLE_RATE >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra H@SSNOWN
CK@HRQCLSL
    Movlw __SET_IDLE
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CK@HRQCLSL1
    Movff __SETUPPKT + __WVALUE + 1,__IDLE_RATE
    Bra H@SSNOWN
CK@HRQCLSL1
    Movlw __GET_PROTOCOL
    Cpfseq __SETUPPKT + __BREQUEST
    Bra CK@HRQCLSL2
NOLIST
if((__ACTIVE_PROTOCOL & 255) == 0)
LIST
    Clrf __PSRC
NOLIST
else
NOLIST
if((__ACTIVE_PROTOCOL & 255) == 255)
LIST
    Setf __PSRC
NOLIST
else
LIST
    Movlw (__ACTIVE_PROTOCOL & 255)
    Movwf __PSRC
NOLIST
endif
NOLIST
endif
NOLIST
if(((__ACTIVE_PROTOCOL >> 8) & 255) == 0)
LIST
    Clrf __PSRCH
NOLIST
else
NOLIST
if(((__ACTIVE_PROTOCOL >> 8) & 255) == 255)
LIST
    Setf __PSRCH
NOLIST
else
LIST
    Movlw ((__ACTIVE_PROTOCOL >> 8) & 255)
    Movwf __PSRCH
NOLIST
endif
NOLIST
endif
LIST
    Movlw 1
    Movwf __WCOUNT
    Clrf __WCOUNTH
    Bcf __USB_STAT,__CTRL_TRF_MEM
    Bra H@SSNOWN
CK@HRQCLSL2
    Movlw __SET_PROTOCOL
    Cpfseq __SETUPPKT + __BREQUEST
    Return
    Movff __SETUPPKT + __WVALUE,__ACTIVE_PROTOCOL
H@SSNOWN
    Movlw __MUID_HID
    Movwf __CTRL_TRF_SESSION_OWNER
    Return
;---------------------------------
HIDINIT@EP
    Movlw 1
    Movwf FSR0L
    Lfsr 1,__HID_REPORT_OUT
    Movlw __HID_INT_OUT_EP_SIZE
    Movwf POSTINC1
    Lfsr 2,UEP0
    Movf FSR0L,W
    Addwf FSR2L,F
    Movlw __EP_OUT | __HSHK_EN
    Iorwf INDF2,F
    Rlncf FSR0L,W
    Rlncf WREG,F
    Rlncf  WREG,F
    Lfsr 0,__EP0BO
    Addwf FSR0L,F
    Movlw __ADRL
    Movff FSR1L,PLUSW0
    Movlw __ADRH
    Movff FSR1H,PLUSW0
    Movf POSTDEC1,W
    INCF FSR0L,F
    Movff INDF1,POSTDEC0
    Movlw _USIE | _DAT0 | _DTSEN
    Movwf INDF0
    Movlw 1
    Movwf FSR0L
    Lfsr 1,__HID_REPORT_IN
    Movlw __HID_INT_IN_EP_SIZE
    Movwf POSTINC1
    Lfsr 2,UEP0
    Movf FSR0L,W
    Addwf FSR2L,F
    Movlw __EP_IN | __HSHK_EN
    Iorwf INDF2,F
    Rlncf FSR0L,W
    Rlncf WREG,F
    Rlncf WREG,F
    Lfsr 0,__EP0BI
    Addwf FSR0L,F
    Movlw __ADRL
    Movff FSR1L,PLUSW0
    Movlw __ADRH
    Movff FSR1H,PLUSW0
    Movlw _UCPU | _DAT1
    Movwf INDF0
    Return

